<?php
/*
Plugin Name: Кредитный калькулятор BelingoCredit
Description: Плагин добавляет шорткод [belingoCredit], который можно использовать на любой странице сайта
Author: Belingo llc
Author URI: https://belingo.ru
Version: 1.0
*/

function belingo_credit_styles() {	
	wp_enqueue_style( 'belingo-credit', plugin_dir_url(__FILE__).'css/style.css' );
}
add_action( 'wp_enqueue_scripts', 'belingo_credit_styles' );

add_shortcode("belingoCredit", "belingoCredit");
function belingoCredit() {

	include('classes/CreditCalcClass.php');

	$calc = new CreditCalcClass();

	if(isset($_POST['process_calc'])) {
		$calc->set('summ', $_POST['credit_summ']);
		$calc->set('period', $_POST['credit_period']);
		$calc->set('procent', $_POST['credit_procent']);
		$calc->set('credit_adv_payment', $_POST['credit_adv_payment']);
		$calc->set('credit_adv_month_payment', $_POST['credit_adv_month_payment']);
		$calc->set('credit_type', $_POST['credit_type']);
		$calc->set('currency', $_POST['currency']);
		$calc->process();
	}

	ob_start();
	if(file_exists(get_template_directory() . '/belingoCredit/belingoCreditTemplate.php')) {
		include_once( get_template_directory() . '/belingoCredit/belingoCreditTemplate.php' );
	}else{
		include_once( WP_PLUGIN_DIR . '/belingoCredit/templates/belingoCreditTemplate.php' );
	}

	$result = ob_get_contents();
	ob_end_clean();
		
	return $result;

}

?>